
use crate::drawableVec::DrawableVec;

use std::collections::{HashMap, BinaryHeap};

use color_eyre::Result;

pub async fn sort(list: &mut DrawableVec) -> Result<()>{

    let mut indexMap:HashMap<u32, usize> = HashMap::new();
    let mut binHeap:BinaryHeap<u32> = BinaryHeap::new();

    let mut ind = 0;
    for bar in list.elements(){
        binHeap.push(*bar);
        indexMap.insert(*bar, ind);
        ind += 1;
    }
    for i in (0..list.len()).rev(){
        let bar = binHeap.pop().unwrap();
        let barIndex = *indexMap.get(&bar).unwrap();
        list.swap(i, barIndex).await?;
        let temp = list.get(barIndex);
        indexMap.insert(temp, barIndex);

    }
    Ok(())
}

/*

#[cfg(test)]
#[allow(non_snake_case)]
mod tests {
  use crate::GuiHookVec::NonGuiVec;

use super::*;
  

  macro_rules! aw {
    ($e:expr) => {
        tokio_test::block_on($e)
    };
  }

  #[test]
  fn binartHeap_correct() {
    let mut list:NonGuiVec = aw!(SortingList::new(1000,0.0));
    aw!(binaryHeap(&mut list));
    assert_eq!( list.isSorted(), true);
  }
}
*/
