use crate::drawableVec::DrawableVec;

use color_eyre::Result;



pub async fn sort(list:&mut DrawableVec) -> Result<()> {
    let mut stack:Vec<(usize,usize)> = Vec::new();

    let start = 0;
    let end = list.len()-1;

    stack.push((start,end));

    while stack.len() > 0{
        let (start,end) = stack.pop().unwrap();

        let p = list.get(end);
        let temp = partition(list, start, end, p).await?;
        let pivot = if temp >= 0 {temp} else {break;};
        
        if pivot != 0 && pivot as usize -1 > start{
            
            stack.push((start,pivot as usize-1));
        }

        if pivot as usize + 1 < end{
            stack.push((pivot as usize +1, end))
        }
    }

    Ok(())

}



async fn partition(list:&mut DrawableVec, low:usize, high:usize, p:u32) -> Result<i32>{
    let mut pIndex = low;

    for i in low..high{
        if list.lessThanEqual(i, p){
            list.swap(i, pIndex).await?;
            pIndex += 1;
        }
    }
    list.swap(pIndex, high).await?;

    return Ok(pIndex as i32)
}
/*
#[cfg(test)]
#[allow(non_snake_case)]
mod tests {
  use crate::GuiHookVec::NonGuiVec;

use super::*;
  

  macro_rules! aw {
    ($e:expr) => {
        tokio_test::block_on($e)
    };
  }

  #[test]
  fn quicksort_correct() {
    let mut list:NonGuiVec = aw!(SortingList::new(1000,0.0));
    aw!(quickSort(&mut list));
    assert_eq!( list.isSorted(), true);
  }
}
*/

